// This file is part of the SV-Benchmarks collection of verification tasks:
// https://gitlab.com/sosy-lab/benchmarking/sv-benchmarks
//
// SPDX-FileCopyrightText: 2020 Aman Goel
// SPDX-FileCopyrightText: 2022 The SV-Benchmarks Community
//
// SPDX-License-Identifier: GPL-3.0-or-later

// This C program is converted from Btor2 by Btor2C version sha1:a0fa249
//   with arguments: { architecture=64, lazy_modulo=true, use_memmove=false, unroll_inner_loops=false, shortest_type=true, diff_type=true, decimal_constant=true, zero_init=false, sra_extend_sign=true }
// Comments from the original Btor2 file:
// ; source: https://github.com/aman-goel/avr/tree/92362931700b66684418a991d018c9fbdbebc06f/tests
// ; BTOR description generated by Yosys 0.9+431 (git sha1 4a3b5437, clang 4.0.1-6 -fPIC -Os) for module main.
extern unsigned char __VERIFIER_nondet_uchar();
extern unsigned short __VERIFIER_nondet_ushort();
extern unsigned int __VERIFIER_nondet_uint();
extern unsigned long __VERIFIER_nondet_ulong();
extern unsigned __int128 __VERIFIER_nondet_uint128();
extern void abort(void);
extern void __assert_fail(const char *, const char *, unsigned int, const char *);
void reach_error() { __assert_fail("0", "mul2.c", 0, "reach_error"); }
void __VERIFIER_assert(int cond) { if (!(cond)) { ERROR: { reach_error(); abort(); } } }
void assume_abort_if_not(int cond) { if (!cond) { abort(); } }
int main() {
  // Defining sorts ...
  typedef unsigned char SORT_1;  // BV with 1 bits
  const SORT_1 mask_SORT_1 = (SORT_1)-1 >> (sizeof(SORT_1) * 8 - 1);
  const SORT_1 msb_SORT_1 = (SORT_1)1 << (1 - 1);
  typedef unsigned long SORT_5;  // BV with 64 bits
  const SORT_5 mask_SORT_5 = (SORT_5)-1 >> (sizeof(SORT_5) * 8 - 64);
  const SORT_5 msb_SORT_5 = (SORT_5)1 << (64 - 1);
  typedef unsigned __int128 SORT_9;  // BV with 128 bits
  const SORT_9 mask_SORT_9 = (SORT_9)-1 >> (sizeof(SORT_9) * 8 - 128);
  const SORT_9 msb_SORT_9 = (SORT_9)1 << (128 - 1);
  // Initializing constants ...
  const SORT_9 var_10 = 0;
  const SORT_1 var_18 = 1;
  const SORT_5 var_22 = 0;
  // Collecting input declarations ...
  SORT_1 input_2;
  SORT_1 input_3;
  SORT_1 input_4;
  SORT_5 input_6;
  SORT_5 input_7;
  SORT_1 input_8;
  // Collecting state declarations ...
  SORT_9 state_11 = __VERIFIER_nondet_uint128() & mask_SORT_9;
  SORT_9 state_13 = __VERIFIER_nondet_uint128() & mask_SORT_9;
  SORT_5 state_23 = __VERIFIER_nondet_ulong() & mask_SORT_5;
  SORT_5 state_25 = __VERIFIER_nondet_ulong() & mask_SORT_5;
  SORT_1 state_27 = __VERIFIER_nondet_uchar() & mask_SORT_1;
  SORT_1 state_29 = __VERIFIER_nondet_uchar() & mask_SORT_1;
  SORT_5 state_31 = __VERIFIER_nondet_ulong() & mask_SORT_5;
  SORT_5 state_33 = __VERIFIER_nondet_ulong() & mask_SORT_5;
  // Initializing states ...
  SORT_9 init_12_arg_1 = var_10;
  state_11 = init_12_arg_1;
  SORT_9 init_14_arg_1 = var_10;
  state_13 = init_14_arg_1;
  SORT_5 init_24_arg_1 = var_22;
  state_23 = init_24_arg_1;
  SORT_5 init_26_arg_1 = var_22;
  state_25 = init_26_arg_1;
  SORT_1 init_28_arg_1 = var_18;
  state_27 = init_28_arg_1;
  SORT_1 init_30_arg_1 = var_18;
  state_29 = init_30_arg_1;
  SORT_5 init_32_arg_1 = var_22;
  state_31 = init_32_arg_1;
  SORT_5 init_34_arg_1 = var_22;
  state_33 = init_34_arg_1;
  for (;;) {
    // Getting external input values ...
    input_2 = __VERIFIER_nondet_uchar();
    input_3 = __VERIFIER_nondet_uchar();
    input_3 = input_3 & mask_SORT_1;
    input_4 = __VERIFIER_nondet_uchar();
    input_4 = input_4 & mask_SORT_1;
    input_6 = __VERIFIER_nondet_ulong();
    input_7 = __VERIFIER_nondet_ulong();
    input_8 = __VERIFIER_nondet_uchar();
    input_8 = input_8 & mask_SORT_1;
    // Assuming invariants ...
    // Asserting properties ...
    SORT_9 var_15_arg_0 = state_11;
    SORT_9 var_15_arg_1 = state_13;
    SORT_1 var_15 = var_15_arg_0 == var_15_arg_1;
    SORT_1 var_19_arg_0 = var_15;
    SORT_1 var_19 = ~var_19_arg_0;
    SORT_1 var_20_arg_0 = var_18;
    SORT_1 var_20_arg_1 = var_19;
    SORT_1 var_20 = var_20_arg_0 & var_20_arg_1;
    var_20 = var_20 & mask_SORT_1;
    SORT_1 bad_21_arg_0 = var_20;
    __VERIFIER_assert(!(bad_21_arg_0));
    // Computing next states ...
    SORT_5 var_36_arg_0 = state_23;
    var_36_arg_0 = var_36_arg_0 & mask_SORT_5;
    SORT_9 var_36 = var_36_arg_0;
    SORT_5 var_37_arg_0 = state_25;
    var_37_arg_0 = var_37_arg_0 & mask_SORT_5;
    SORT_9 var_37 = var_37_arg_0;
    SORT_9 var_38_arg_0 = var_36;
    SORT_9 var_38_arg_1 = var_37;
    SORT_9 var_38 = var_38_arg_0 * var_38_arg_1;
    SORT_1 var_39_arg_0 = input_8;
    SORT_9 var_39_arg_1 = var_10;
    SORT_9 var_39_arg_2 = var_38;
    SORT_9 var_39 = var_39_arg_0 ? var_39_arg_1 : var_39_arg_2;
    var_39 = var_39 & mask_SORT_9;
    SORT_9 next_40_arg_1 = var_39;
    SORT_1 var_44_arg_0 = state_27;
    SORT_1 var_44_arg_1 = state_29;
    SORT_1 var_44 = var_44_arg_0 | var_44_arg_1;
    var_44 = var_44 & mask_SORT_1;
    SORT_5 var_41_arg_0 = state_31;
    var_41_arg_0 = var_41_arg_0 & mask_SORT_5;
    SORT_9 var_41 = var_41_arg_0;
    SORT_5 var_42_arg_0 = state_33;
    var_42_arg_0 = var_42_arg_0 & mask_SORT_5;
    SORT_9 var_42 = var_42_arg_0;
    SORT_9 var_43_arg_0 = var_41;
    SORT_9 var_43_arg_1 = var_42;
    SORT_9 var_43 = var_43_arg_0 * var_43_arg_1;
    SORT_1 var_45_arg_0 = var_44;
    SORT_9 var_45_arg_1 = var_43;
    SORT_9 var_45_arg_2 = state_13;
    SORT_9 var_45 = var_45_arg_0 ? var_45_arg_1 : var_45_arg_2;
    SORT_1 var_46_arg_0 = input_8;
    SORT_9 var_46_arg_1 = var_10;
    SORT_9 var_46_arg_2 = var_45;
    SORT_9 var_46 = var_46_arg_0 ? var_46_arg_1 : var_46_arg_2;
    var_46 = var_46 & mask_SORT_9;
    SORT_9 next_47_arg_1 = var_46;
    SORT_1 var_48_arg_0 = input_3;
    SORT_5 var_48_arg_1 = input_6;
    SORT_5 var_48_arg_2 = state_23;
    SORT_5 var_48 = var_48_arg_0 ? var_48_arg_1 : var_48_arg_2;
    SORT_1 var_49_arg_0 = input_8;
    SORT_5 var_49_arg_1 = var_22;
    SORT_5 var_49_arg_2 = var_48;
    SORT_5 var_49 = var_49_arg_0 ? var_49_arg_1 : var_49_arg_2;
    SORT_5 next_50_arg_1 = var_49;
    SORT_1 var_51_arg_0 = input_4;
    SORT_5 var_51_arg_1 = input_7;
    SORT_5 var_51_arg_2 = state_25;
    SORT_5 var_51 = var_51_arg_0 ? var_51_arg_1 : var_51_arg_2;
    SORT_1 var_52_arg_0 = input_8;
    SORT_5 var_52_arg_1 = var_22;
    SORT_5 var_52_arg_2 = var_51;
    SORT_5 var_52 = var_52_arg_0 ? var_52_arg_1 : var_52_arg_2;
    SORT_5 next_53_arg_1 = var_52;
    SORT_1 var_54_arg_0 = input_8;
    SORT_1 var_54_arg_1 = var_18;
    SORT_1 var_54_arg_2 = input_3;
    SORT_1 var_54 = var_54_arg_0 ? var_54_arg_1 : var_54_arg_2;
    SORT_1 next_55_arg_1 = var_54;
    SORT_1 var_56_arg_0 = input_8;
    SORT_1 var_56_arg_1 = var_18;
    SORT_1 var_56_arg_2 = input_4;
    SORT_1 var_56 = var_56_arg_0 ? var_56_arg_1 : var_56_arg_2;
    SORT_1 next_57_arg_1 = var_56;
    SORT_1 var_58_arg_0 = input_3;
    SORT_5 var_58_arg_1 = input_6;
    SORT_5 var_58_arg_2 = state_31;
    SORT_5 var_58 = var_58_arg_0 ? var_58_arg_1 : var_58_arg_2;
    SORT_1 var_59_arg_0 = input_8;
    SORT_5 var_59_arg_1 = var_22;
    SORT_5 var_59_arg_2 = var_58;
    SORT_5 var_59 = var_59_arg_0 ? var_59_arg_1 : var_59_arg_2;
    SORT_5 next_60_arg_1 = var_59;
    SORT_1 var_61_arg_0 = input_4;
    SORT_5 var_61_arg_1 = input_7;
    SORT_5 var_61_arg_2 = state_33;
    SORT_5 var_61 = var_61_arg_0 ? var_61_arg_1 : var_61_arg_2;
    SORT_1 var_62_arg_0 = input_8;
    SORT_5 var_62_arg_1 = var_22;
    SORT_5 var_62_arg_2 = var_61;
    SORT_5 var_62 = var_62_arg_0 ? var_62_arg_1 : var_62_arg_2;
    SORT_5 next_63_arg_1 = var_62;
    // Assigning next states ...
    state_11 = next_40_arg_1;
    state_13 = next_47_arg_1;
    state_23 = next_50_arg_1;
    state_25 = next_53_arg_1;
    state_27 = next_55_arg_1;
    state_29 = next_57_arg_1;
    state_31 = next_60_arg_1;
    state_33 = next_63_arg_1;
  }
  return 0;
}
